#
# global commands to do with window management
# for ascend
# (C) Ben Allan, Kirk Abbott 1994
# $Revision: 1.44 $
# $Date: 97/09/16 16:20:04 $


#
# proc ascsetdebug {{on 1}}
# -------------------------------------------------------------------------
# Note that in the following we see the feature that all tcl procs are
# global and that procedures may define procedures.
# Use examples:
# ascsetdebug 0
#   this turns debugging spew info off.
# ascsetdebug 1
#   this turns debugging spew info on.
# ascsetdebug
#   this also turns debugging spew on because the DEFAULT given is 1.
# -------------------------------------------------------------------------
proc ascsetdebug {{on 1}} {
  if {$on} {
    proc entertrace {args} {
        set depth [expr {[info level]-1}]
        puts "entering [lindex [info level $depth] 0] : $args"
    }
    proc leavetrace {args} {
        set depth [expr {[info level]-1}]
        puts "leaving [lindex [info level $depth] 0] : $args"
    }
  } else {
    proc entertrace {args} {}
    proc leavetrace {args} {}
  }
}

ascsetdebug 0

# requires double braces to deal with xfs dot qualified procedure names.

#
# proc awin {window}
#-----------------------------------------------------------------------
# start (or destroy) windows. awin help for detail
#-----------------------------------------------------------------------
proc awin {window} {

  global xfShowWindow.browser xfShowWindow.display xfShowWindow.library
  global xfShowWindow.probe   xfShowWindow.script
  global xfShowWindow.solver  xfShowWindow.toolbox xfShowWindow.units
  global xfShowWindow.debug   xfShowWindow.mtx
  global ascSolvVect
  global env

  switch $window {
 # getting the toolbox requires all its attachments.
    {t*} -
    {all} -
    {t*} -
    {T*} {
              set xfShowWindow.browser 1
              ShowWindow.browser
              puts -nonewline "."; flush stdout
              set xfShowWindow.display 1
              ShowWindow.display
              puts -nonewline "."; flush stdout
              set xfShowWindow.library 1
              ShowWindow.library
              puts -nonewline "."; flush stdout
              set xfShowWindow.probe 1
              ShowWindow.probe
              puts -nonewline "."; flush stdout
              set xfShowWindow.script 1
              ShowWindow.script
              puts -nonewline "."; flush stdout
              set xfShowWindow.solver 1
              ShowWindow.solver
              puts -nonewline "."; flush stdout
              set xfShowWindow.units 1
              ShowWindow.units
              puts -nonewline "."; flush stdout
              set xfShowWindow.toolbox 1
              ShowWindow.toolbox
              puts "."; flush stdout
              update idletask
 # resource everything
              puts "source $env(ASCENDTK)/ToolboxProc.tcl"
              source "$env(ASCENDTK)/ToolboxProc.tcl"
              puts "source $env(ASCENDTK)/UtilProc.tcl"
              source "$env(ASCENDTK)/UtilProc.tcl"
              puts "source $env(ASCENDTK)/DisplayProc.tcl"
              source "$env(ASCENDTK)/DisplayProc.tcl"
              puts "source $env(ASCENDTK)/UnitsProc.tcl"
              source "$env(ASCENDTK)/UnitsProc.tcl"
              puts "source $env(ASCENDTK)/ProbeProc.tcl"
              source "$env(ASCENDTK)/ProbeProc.tcl"
              puts "source $env(ASCENDTK)/LibraryProc.tcl"
              source "$env(ASCENDTK)/LibraryProc.tcl"
              puts "source $env(ASCENDTK)/TypetreeProc.tcl"
              source "$env(ASCENDTK)/TypetreeProc.tcl"
              puts "source $env(ASCENDTK)/BrowserProc.tcl"
              source "$env(ASCENDTK)/BrowserProc.tcl"
              puts "source $env(ASCENDTK)/DebugProc.tcl"
              source "$env(ASCENDTK)/DebugProc.tcl"
              puts "source $env(ASCENDTK)/MtxProc.tcl"
              source "$env(ASCENDTK)/MtxProc.tcl"
              puts "source $env(ASCENDTK)/SolverProc.tcl"
              source "$env(ASCENDTK)/SolverProc.tcl"
              puts "source $env(ASCENDTK)/ScriptProc.tcl"
              source "$env(ASCENDTK)/ScriptProc.tcl"
              puts "source $env(ASCENDTK)/WWWHelpProc.tcl"
              source "$env(ASCENDTK)/WWWHelpProc.tcl"
              puts "source $env(ASCENDTK)/HubProc.tcl"
              source "$env(ASCENDTK)/HubProc.tcl"
              puts "source $env(ASCENDTK)/mps.tcl"
              source "$env(ASCENDTK)/mps.tcl"
#             puts "Wiring up the buttons..."
              set_Browser_Defaults
#             if {[catch {set_Browser_Defaults} ]} {puts "BrowDefSet failed"}
              set_Display_Defaults
#             if {[catch {set_Display_Defaults} ]} {puts "DispDefSet failed"}
              set_Library_Defaults
#             if {[catch {set_Library_Defaults} ]} {puts "LibrDefSet failed"}
              set_Typetree_Defaults
#             if {[catch {set_Typetree_Defaults} ]} {puts "TypeDefSet failed"}
              set_Probe_Defaults
#             if {[catch {set_Probe_Defaults} ]} {puts "ProbDefSet failed"}
              set_Script_Defaults
#             if {[ catch {set_Script_Defaults} screrr]}  {
#               puts "ScripDefSet failed"
#               puts $screrr
#             }
              set_Solver_Defaults
#             if {[ catch {set_Solver_Defaults} ]} {puts "SolvDefSet failed"}
              set_Debug_Defaults
#             if {[ catch {set_Debug_Defaults} ]} {puts "DebuDefSet failed"}
              set_Mtx_Defaults
#             if {[ catch {set_Mtx_Defaults} ]}   {puts "MtxDefSet failed"}
              set_Units_Defaults
#             if {[ catch {set_Units_Defaults} ]} {puts "UnitDefSet failed"}
              set_Toolbox_Defaults
#             if {[ catch {set_Toolbox_Defaults} ]} {puts "ToolDefSet failed"}
              set_Util_Defaults
#             if {[ catch {set_Util_Defaults} ]}  {puts "UtilDefSet failed"}
              set_HUB_Defaults
#             if {[ catch {set_HUB_Defaults} ]}   {puts "HUBDefSet failed"}
              set_Help_Defaults
#             if {[ catch {set_Help_Defaults} ]}  {puts "HelpDefSet failed"}

           }
     {b*} -
     {B*} {set xfShowWindow.browser 1
           ShowWindow.browser
           puts "source $env(ASCENDTK)/BrowserProc.tcl"
           source "$env(ASCENDTK)/BrowserProc.tcl"
           set_Browser_Defaults
           update idletask}

     {d*} -
     {D*} {set xfShowWindow.display 1
           ShowWindow.display
           puts "source $env(ASCENDTK)/DisplayProc.tcl"
#           update idletask
           source "$env(ASCENDTK)/DisplayProc.tcl"
           set_Display_Defaults
           update idletask}

     {l*} -
     {L*} {set xfShowWindow.library 1
           ShowWindow.library
           puts "source $env(ASCENDTK)/LibraryProc.tcl"
#           update idletask
           source "$env(ASCENDTK)/LibraryProc.tcl"
           set_Library_Defaults
           update idletask}

     {p*} -
     {P*} {set xfShowWindow.probe 1
           ShowWindow.probe
           puts "source $env(ASCENDTK)/ProbeProc.tcl"
#           update idletask
           source "$env(ASCENDTK)/ProbeProc.tcl"
           set_Probe_Defaults
           update idletask}

     {sc*} -
     {Sc*} -
     {SC*} {set xfShowWindow.script 1
            ShowWindow.script
            puts "source $env(ASCENDTK)/ScriptProc.tcl"
#            update idletask
            source "$env(ASCENDTK)/ScriptProc.tcl"
            set_Script_Defaults
            update idletask}

 # theoretically  the general parameters are always there
     {so*} -
     {So*} -
     {SO*} { set xfShowWindow.solver 1
            ShowWindow.solver
            puts "source $env(ASCENDTK)/SolverProc.tcl"
#            update idletask
            source "$env(ASCENDTK)/SolverProc.tcl"
            set_Solver_Defaults
            update idletask}

      {u*} -
      {U*} {set xfShowWindow.units 1
            ShowWindow.units
            puts "source $env(ASCENDTK)/UnitsProc.tcl"
#            update idletask
            source "$env(ASCENDTK)/UnitsProc.tcl"
            set_Units_Defaults
            update idletask}

      {noall} -
      {noT*} -
      {not*} {
               if {${xfShowWindow.toolbox}} {DestroyWindow.toolbox
                                             DestroyWindow.util}
               if {${xfShowWindow.browser}} {DestroyWindow.browser}
               if {${xfShowWindow.display}} {DestroyWindow.display}
               if {${xfShowWindow.library}} {DestroyWindow.library}
               if {${xfShowWindow.probe}} {DestroyWindow.probe}
               if {${xfShowWindow.script}} {DestroyWindow.script}
               if {${xfShowWindow.solver}} {DestroyWindow.solver}
               if {${xfShowWindow.units}} {DestroyWindow.units}
               set xfShowWindow.browser 0
               set xfShowWindow.display 0
               set xfShowWindow.library 0
               set xfShowWindow.probe 0
               set xfShowWindow.script 0
               set xfShowWindow.solver 0
               set xfShowWindow.units 0
               set xfShowWindow.toolbox 0
               update idletask }

       {nob*} - 
       {noB*} {if {${xfShowWindow.browser}} {DestroyWindow.browser}
                    set xfShowWindow.browser 0}

       {nod*} -
       {noD*} {if {${xfShowWindow.browser}} {DestroyWindow.browser}
                    set xfShowWindow.display 0}

       {nol*} -
       {noL*} {if {${xfShowWindow.library}} {DestroyWindow.library}
                    set xfShowWindow.library 0}

       {nop*} -
       {noP*} {if {${xfShowWindow.probe}} {DestroyWindow.probe}
                    set xfShowWindow.probe 0}

       {nosc*} -
       {noSC*} -
       {noSc*} {if {${xfShowWindow.script}} {DestroyWindow.script}
                            set xfShowWindow.script 0}

       {noso*} -
       {noSo*} -
       {noSO*} {
               if {${xfShowWindow.solver}} {DestroyWindow.solver}
               set xfShowWindow.solver 0}

        {noU*} -
        {nou*} {if {${xfShowWindow.units}} {DestroyWindow.units}
                     set xfShowWindow.units 0}
        default { puts "awin syntax: awin \[no\]arg"
                  puts "     where arg is 'all' or the name of a window." }
    }
 #end switch
  set_ascplot_defaults
 #  update idletask
 #  update
}
 # end awin

#
# proc asc_fixiconnames {}
#-----------------------------------------------------------------------
# asc iconname silliness under twm, maybe mwm. once the hurly burly's done,
# call this. still buggy under sun3twm
#-----------------------------------------------------------------------
proc asc_fixiconnames {} {
  global ascBrowVect ascLibrVect ascSolvVect ascProbVect
  global ascToolVect ascSimsVect ascUnitVect ascDispVect
  global ascScripVect

  catch {wm iconname .browser}
  catch {wm title .}
  catch {wm iconname .}
  catch {wm iconname .display}
  catch {wm iconname .library}
  catch {wm iconname .probe}
  catch {wm iconname .script}
  catch {wm iconname .solver}
  catch {wm iconname .units }
  catch {wm iconname .toolbox}
  wm title . "Ascend IV"
  wm iconname . "Ascend IV"
  # update idletasks
  wm title . "Ascend IV"
  wm iconname .browser $ascBrowVect(iconname)
  wm iconname .display $ascDispVect(iconname)
  wm iconname .library $ascLibrVect(iconname)
  wm iconname .probe $ascProbVect(iconname)
  wm iconname .script $ascScripVect(iconname)
  wm iconname .solver $ascSolvVect(iconname)
  wm iconname .toolbox $ascToolVect(iconname)
  wm iconname .units $ascUnitVect(iconname)

}

#
# proc Redraw {}
#-----------------------------------------------------------------------
# Repaint info (as much as possible) from C structure after interface 
# resourced
#-----------------------------------------------------------------------
proc Redraw {} {
  Libr_Redraw
  Solve_Redraw
  Probe_Redraw
  Units_Redraw
  Sims_Redraw
}

#
# Binding hacks for Tk widgets in ASCEND.
# Ben Allan, 5/97.
#
proc set_cmuBindings {} {
  global tcl_platform tk_strictMotif
# we don't understand why scanning is supposed to work only with
# b1 down. haven't been able to find any unwanted side effects of this
# baa 6/12/97, tk80b1-no patches
  bind Menubutton <Motion> {
    global tk_strictMotif
    if {$tk_strictMotif} {
      tkMbMotion %W up %X %Y
    } else {
      tkMbMotion %W down %X %Y
    }
  }
# puts "Adding cmu Entry and Text bindings"
  #
  # Entries:
  #
  # define Ctrl-u for unix folks.
  bind Entry <Control-Key-u> {
    if !$tk_strictMotif {
      %W delete 0 end
    }
  }
  #
  #define delete and backspace to be backspace.
  bind Entry <Key-Delete> {
    if !$tk_strictMotif {
      tkEntryBackspace %W
    }
  }
  #
  #Texts
  #
  # munge both backspace and delete to
  if {$tcl_platform(platform)=="unix" && !$tk_strictMotif} {
    # the standard tcl text bindings. Swap them.
    # bind Text <Delete> {
    #    if {[%W tag nextrange sel 1.0 end] != ""} {
    #        %W delete sel.first sel.last
    #    } else {
    #        %W delete insert
    #        %W see insert
    #    }
    #}
    #bind Text <BackSpace> {
    #    if {[%W tag nextrange sel 1.0 end] != ""} {
    #        %W delete sel.first sel.last
    #    } elseif [%W compare insert != 1.0] {
    #        %W delete insert-1c
    #        %W see insert
    #    }
    #}
    bind Text <BackSpace> {
        if {[%W tag nextrange sel 1.0 end] != ""} {
            %W delete sel.first sel.last
        } else {
            %W delete insert
            %W see insert
        }
    }
    bind Text <Delete> {
        if {[%W tag nextrange sel 1.0 end] != ""} {
            %W delete sel.first sel.last
        } elseif [%W compare insert != 1.0] {
            %W delete insert-1c
            %W see insert
        }
    }
  }
  if {!$tk_strictMotif} {
    if {$tcl_platform(platform) =="windows"} {
      bind Text <Control-Key-x> {
          asctk_textCut %W
      }
      bind Text <Control-Key-c> {
          asctk_textCopy %W
      }
      bind Text <Control-Key-v> {
          asctk_textPaste %W
      }
    }
    proc asctk_textCut {w} {
        set expo [$w cget -exportselection]
        $w configure exportselection 1
        selection own $w
        tk_textCut $w
        $w configure -exportselection $expo
    }
    proc asctk_textCopy {w} {
        set expo [$w cget -exportselection]
        $w configure -exportselection 1
        selection own $w
        tk_textCopy $w
        $w configure -exportselection $expo
    }
    proc asctk_textPaste {w} {
        set expo [$w cget -exportselection]
        $w configure -exportselection 1
        tk_textPaste $w
        $w configure -exportselection $expo
    }
  }
}
#
# proc set_Global_Defaults {}
#-----------------------------------------------------------------------
# proc set_Global_Defaults
# These following must be set here to control window creation in Main.
#-----------------------------------------------------------------------
proc set_Global_Defaults {} {
  set_cmuBindings

  global tkselerrmsg env tcl_platform asc_tkfbox
  global ascBrowVect ascLibrVect ascSolvVect ascProbVect ascDebuVect
  global ascToolVect ascSimsVect ascUnitVect ascDispVect ascGlobalVect
  global ascScripVect ascMtxVect

  set tkselerrmsg "selection doesn't exist or form \"STRING\" not defined"
  puts stderr $env(ASCENDLIBRARY)
  if {[info exists env(ASCENDLIBRARY)] == 0} {
    puts stderr "setting lib in global to [pwd]"
    set env(ASCENDLIBRARY) [pwd]
  }
  set ascGlobalVect(librarypathdirs) ""
  if {$tcl_platform(platform) == "unix"} {
    set ascGlobalVect(librarypathdirs) [split $env(ASCENDLIBRARY) :]
  } else { #windoze. mac?
    set ascGlobalVect(librarypathdirs) [split $env(ASCENDLIBRARY) \;]
  }
  set slist ""
  set s 0
  catch {set slist [slv_available]}
  set ascSolvVect(numberofsolvers) [llength $slist]
  foreach i $slist {
    set ascSolvVect(name.$s) $i
    if {[string range $i 0 2]=="no_"} {
      set ascSolvVect(available.$s) 0
      set ascSolvVect(name.$s) [string range $i 3 end]
    } else { set ascSolvVect(available.$s) 1}
    incr s
  }

  set winshortlist \
     "Solv Brow Libr Prob Debu Tool Scrip Mtx Unit Disp Global"
  foreach w $winshortlist {
    set asc${w}Vect(initialstate) "withdrawn"
    set asc${w}Vect(geometry) "200x200+10+10"
    set asc${w}Vect(iconname) $w
    set asc${w}Vect(font) {helvetica 12 bold}
    set asc${w}Vect(visibility) 1
  }
  #this next line sets the toolbitmap under the assumption that GlobalProc
  # will never be present under xf. toolAttributes is C-registered
  set ascGlobalVect(toolbitmap) toolAttributes

  set ascToolVect(initialstate) "withdrawn"
  set ascGlobalVect(maxutilrow) 8
  set ascGlobalVect(hideinfo) 0
  set ascGlobalVect(warrinfo) 0
  set ascGlobalVect(liceinfo) 0
  set ascGlobalVect(authinfo) 0

  set ascDebuVect(windowname) .debug
  set ascDispVect(windowname) .display
  set ascMtxVect(windowname) .mtx
  set ascScripVect(windowname) .script
  set ascToolVect(windowname) .toolbox
  set ascUnitVect(windowname) .units
  set ascSolvVect(windowname) .solver
  set ascBrowVect(windowname) .browser
  set ascLibrVect(windowname) .library
  set ascProbVect(windowname) .probe
 # do the option database load which will override above settings
 # the next line sets a dummy value for ScrollCommand at a low
 # priority. if you see NoFunction returned from an option query
 # you should apply some default instead. The tk Class default for
 # ScrollCommand is {} so NoFunction is ok.
  option add *ScrollComand NoFunction 20
#
# New tcl file ascend.ad
# View contains the procedures required by ascend.ad
#
  puts "source $env(ASCENDTK)/View.tcl"
  source "$env(ASCENDTK)/View.tcl"
  puts "source $env(ASCENDTK)/ascend.ad"
  source $env(ASCENDTK)/ascend.ad
  if {[catch {source [glob ~/.ascend.ad]} aderror]} {
    if {[file exists ~/.ascend.ad]} {
      puts $aderror
    }
  }
  if {$tcl_platform(platform) == "windows"} {
    if {[catch {source [glob ~/_ascend.ad]} aderror]} {
      if {[file exists ~/_ascend.ad]} {
        puts $aderror
      }
    }
  }
  set_View_Option_Values
#
# # make ascend global ->Xglobal
# # do not add these at priorities >=20 as this will give conflicts
# # when reading the options with Foreground in get_opt
#   option add *Font $ascGlobalVect(font) 60
   option add *Text*Foreground $ascGlobalVect(tfg) 40
   option add *Listbox*Foreground $ascGlobalVect(tfg) 40
   option add *Text*Background $ascGlobalVect(tbg) 40
   option add *Listbox*Background $ascGlobalVect(tbg) 40
#   option add *Background $ascGlobalVect(bg) 60
#   option add *Foreground $ascGlobalVect(fg) 60
#  # initialize read/write virtual.
  __userdata_init
  set ascGlobalVect(w_load) "1"
}

# set color/etc vectors for transients with arrays
proc set_Template_defaults {} {
  global ascGlobalVect
  global AscMonoEntry1  AscMonoEntry2 AscConfirm VPaned
  global AscPopSlide ascParPageVect   ascMsgVect
  global ascListSelectBox ascListSelectB1Box
  set AscMonoEntry1(font) $ascGlobalVect(font)
  set AscMonoEntry2(font) $ascGlobalVect(font)
  set AscConfirm(font) $ascGlobalVect(font)
  set VPaned(knobcolor) white
  set AscPopSlide(font) $ascGlobalVect(font)
  set ascParPageVect(btn_font) $ascGlobalVect(font)
  set ascListSelectB1Box(font) $ascGlobalVect(font)
  set ascListSelectB1Box(grab) 1
  set ascListSelectBox(font) $ascGlobalVect(font)
  set ascListSelectBox(grab) 1
  set ascMsgVect(lbl_font) $ascGlobalVect(font)
  set ascMsgVect(btn_font) $ascGlobalVect(font)
}

#
# proc Glob_do_GNU {}
#-----------------------------------------------------------------------
# the gnubutton callback
#-----------------------------------------------------------------------
 # d_dumpfile defined in generalk.tcl, so this is silent until main loads
 # generalk
proc Glob_do_GNU {} {
 # old version
 #  global env
 #  set path "[lindex [split $env(ASCENDHELP) :] 0]/notices/startup"
 #  catch {d_dumpfile stdout $path}
 #  wm iconify .
  ascShowInfo
}

proc ascShowInfo {} {
  global ascGlobalVect env

  wm withdraw .
  if {[winfo exists .itop]==1} {
    destroy .itop
  }
  if {$ascGlobalVect(hideinfo)==1} {
    return
  }
  set f .itop.info
  wm title . "ASCEND IV"
  toplevel .itop
  wm positionfrom .itop user
  wm title .itop "ASCEND IV"
  wm iconname .itop "ASCEND IV"
  frame $f -highlightthickness 2 -borderwidth 2 -relief sunken
  set t $f.text
  text $t -yscrollcommand "$f.scroll set" -setgrid true \
          -font {Helvetica 12} -width 80 -exportselection 0 \
	  -height 35 -wrap word -highlightthickness 0 -borderwidth 0
  pack append $f $t {right frame center expand fill}
  scrollbar $f.scroll -command "$t yview"
  pack append $f $f.scroll {left frame center expand filly}
  pack append .itop $f {bottom frame center expand fill}
  $t tag configure center -justify center -spacing1 5m -spacing3 5m
  $t tag configure buttons -lmargin1 1c -lmargin2 1c -rmargin 1c \
	  -spacing1 3m -spacing2 0 -spacing3 0

  button $t.click -text "Authors" \
    -command "ascAuthInfo"  \
    -cursor top_left_arrow
  button $t.delete -text "Help (starts browser)" \
    -command  {Script_getting_started}  \
    -cursor top_left_arrow
  button $t.goaway -text "Dismiss" \
    -command "set ascGlobalVect(hideinfo) 1; ascShowInfo"  \
    -cursor top_left_arrow
  button $t.die -text "Dismiss forever" \
    -command {bell; puts stderr "WE_SHOULD_FIX_THIS_TOO"}  \
    -cursor top_left_arrow
  button $t.gnu_btn \
    -bitmap "@$env(ASCENDBITMAPS)/gnu-ascend.xbm" \
    -state normal \
    -text {}


  $t insert end "                       ASCEND IV\n"
  $t insert end "Advanced System for Computations in ENgineering Design\n"
  $t insert end "(C) Copyright 1992-1997 Carnegie Mellon University\n"
  $t insert end "\n"
  $t insert end "Click on the buttons below if you want to see the details. "
  $t insert end "When you click, the text required gets added to this box. "
  $t insert end "Use the scrollbar to read through the added text.\n\n"
  $t insert end "By using ASCEND IV you are agreeing to the terms of "
  $t insert end "the GNU Public License and Warranty in the first Script:."
  $t insert end "License-Warranty.tcl\n"
  $t insert end "\n"
  $t insert end "ASCEND was developed by the students of Art Westerberg "
  $t insert end "from 1984 to 1997. A number of other students have also "
  $t insert end "contributed models to the ASCEND libraries. A list "
  $t insert end "of the known contributors (in any capacity) is here:  "
  $t window create end -window $t.click
  $t insert end "(Please let us know if we missed you.)"
  $t insert end "\n"
  $t insert end "\n"
  $t insert end "Help for getting started with ASCEND should be available "
  $t insert end "locally through your WWW browser by clicking here: "
  $t window create end -window $t.delete
  $t insert end "\n"
  $t insert end "If that doesn't work, see your ASCEND maintainer or point "
  $t insert end "your browser at\n "
  $t insert end "       http://www.cs.cmu.edu/~ascend/help/beginner.htm\n"
  $t insert end "(you should be able to paste the address above with a mouse)"
  $t insert end " where you will find links to our on-line help and our bug "
  $t insert end "report form.\n\n"
  $t insert end "  E-mail: ascend+help@cs.cmu.edu\n\n"

  $t insert end "        "
  $t window create end -window $t.goaway
  $t insert end "        "
  $t window create end -window $t.die
  $t insert end "\n\n           "
  $t window create end -window $t.gnu_btn
  $t insert end "\n\n"
  if {$ascGlobalVect(hideinfo)==1} {
    wm withdraw .itop
  } else {
    wm deiconify .itop
    after 25000 {if {[winfo exists .itop]} {wm withdraw .itop}}
  }
}

#
# proc ascAuthInfo {}
#_________________________________________________________________
# pops up a tkdialog with the content of TK/WhoDunnit.tcl
# all merged into a single string.
#_________________________________________________________________
proc ascAuthInfo {} {
  global env
  set fileInFile [open $env(ASCENDTK)/WhoDunnit.tcl r]
  set textValue [read $fileInFile]
  regsub -all \n $textValue { } textValue2
  tk_dialog .authinfo "ASCEND Authors" $textValue2 toolAttributes 0 OK
}
