#
# Code for the toolbox buttons and aliases
# (C) Kirk Abbott, Ben Allan 1994
#  $Revision: 1.12 $
# $Date: 97/08/01 21:48:59 $
#


#
# proc set_Toolbox_Defaults {}
#------------------------------------------------------------------------
# startup  toolbox vars
#------------------------------------------------------------------------
proc set_Toolbox_Defaults {} {

  global ascToolVect ascGlobalVect {xfShowWindow.toolbox}
  global env
  if {${xfShowWindow.toolbox}} {

 #   puts "setting toolbox buttons"
    set ascToolVext(windowname) .toolbox
    set ascToolVect(dirargs) [pwd]
    set ascToolVect(dirinput) [pwd]
    set ascToolVect(printargs) "xa2ps -Pmirage"
    set ascToolVect(exitargs) ""

    global ascToolVect

    set ascToolVect(utilBtn) .toolbox.bottom_frm.util_btn
    set ascToolVect(helpBtn) .toolbox.bottom_frm.hlp_btn
    set ascToolVect(exitBtn) .toolbox.bottom_frm.exit_btn
    set ascToolVect(librBtn) .toolbox.bottom_frm.library_btn
    set ascToolVect(browBtn) .toolbox.bottom_frm.browser_btn
    set ascToolVect(solvBtn) .toolbox.bottom_frm.solver_btn
    set ascToolVect(probBtn) .toolbox.bottom_frm.probe_btn
    set ascToolVect(unitBtn) .toolbox.bottom_frm.units_btn
    set ascToolVect(dispBtn) .toolbox.bottom_frm.display_btn
    set ascToolVect(scripBtn) .toolbox.bottom_frm.script_btn

    # set ptr
    .toolbox configure -cursor left_ptr

    Configure_Toolbox

  } else {
    puts "toolbox doesn't exist! buttons not set"
  }
}

#
# proc Configure_Toolbox {}
#------------------------------------------------------------------------
# Now attaching some do_raise_lower procedures to the items of
# the Toolboxand the Toolbox itself. -- attached to its label.!!
#------------------------------------------------------------------------
proc Configure_Toolbox {} {
  global ascToolVect

  $ascToolVect(librBtn)   configure -command {Toggle_Remote ascLibrVect}
  $ascToolVect(browBtn)   configure -command {Toggle_Remote ascBrowVect}
  $ascToolVect(solvBtn)  configure -command {Toggle_Remote ascSolvVect}
  $ascToolVect(probBtn)  configure -command {Toggle_Remote ascProbVect}
  $ascToolVect(unitBtn)  configure -command {Toggle_Remote ascUnitVect}
  $ascToolVect(dispBtn)   configure -command {Toggle_Remote ascDispVect}
  $ascToolVect(scripBtn) configure -command {do_raise_lower .script}

  $ascToolVect(helpBtn)  configure -command Tool_do_Help
  $ascToolVect(exitBtn)   configure -command Tool_exit
}


#
# proc Tool_do_UtilBox {}
#------------------------------------------------------------------------
# utility box button
#------------------------------------------------------------------------
proc Tool_do_UtilBox {} {
  VShowWindow.util 0
}

#
# proc Tool_do_Bugs {}
#------------------------------------------------------------------------
# bug mail call button
#------------------------------------------------------------------------
proc Tool_do_Bugs {} {
  Help_button toolbox.bugreport
}

#
# proc Tool_do_Help {}
#------------------------------------------------------------------------
# help button for toolbox. starts up help
#------------------------------------------------------------------------
proc Tool_do_Help {} {
  Help_Open
}

#
# proc Tool_set_dir {}
#------------------------------------------------------------------------
# should be modified to work with util box
#------------------------------------------------------------------------
proc Tool_set_dir {} {

  global ascToolVect

  if {$ascToolVect(dirinput) == ""}  {
    set ascToolVect(dirinput) [eval "pwd"];
  }
  if {[file isdirectory $ascToolVect(dirinput)]} {
    set ascToolVect(dirargs) $ascToolVect(dirinput);
    return;
  } else {
    set errmsg "Directory\n"
    append errmsg $ascToolVect(dirinput)
    append errmsg "\n not found!"
    Script_Raise_Alert $errmsg "Path Error"
    set ascToolVect(dirinput) $ascToolVect(dirargs)
    error "bad directory";
  }
}

#
# proc Tool_printinstr
#------------------------------------------------------------------------
# sanity check on print option string. weak.
#------------------------------------------------------------------------
proc Tool_printinstr {} {

  global ascToolVect
  global env
  if {$ascToolVect(printargs) == ""}  {
    set ascToolVect(printargs) "lpr -P $env(PRINTER)"
    return;
  }
}

#
# proc Tool_ExitGeom {}
#------------------------------------------------------------------------
# calc some misc geometry for exit widget to be near exit button
#------------------------------------------------------------------------
proc Tool_ExitGeom {} {

  #set geom [wm geometry .toolbox]
  #set data [split $geom "x+"]
  #set xpos [lindex $data 0]
  #set ypos [lindex $data 1]
  #set xoff [lindex $data 2]
  #set yoff [lindex $data 3]
  #set centrx [expr $xpos / 2 + $xoff - 190 / 2]
  #set centry [expr $ypos / 2 + $yoff]
  #return "$centrx\+$centry"
  return [setpos .toolbox.bottom_frm.exit_btn 20 12]
}

#
# proc ExitProbe
#------------------------------------------------------------------------
# flush probe C structures.  call on ascend exit only.
#------------------------------------------------------------------------
proc ExitProbe {} {
  __probe destroy
}
#
# proc ExitLibrary {}
#------------------------------------------------------------------------
# flush the library and interface module lists. call on ascend exit only.
#------------------------------------------------------------------------
proc ExitLibrary {} {
  libr_destroy_types
  libr_destroy_libr
}

#
# proc ExitUnits {}
#------------------------------------------------------------------------
# flush the library and interface module lists. call on ascend exit only.
#------------------------------------------------------------------------
proc ExitUnits {} {
  u_destroy_units
}

#
# proc ExitIVP {}
#------------------------------------------------------------------------
# empty integrate interface buffers steps and filenames
#------------------------------------------------------------------------
proc ExitIVP {} {
  integrate_set_samples
  integrate_set_y_file ""
  integrate_set_obs_file ""
}

#
# proc Tool_exit {}
#------------------------------------------------------------------------
# the exit button callup
#------------------------------------------------------------------------
proc Tool_exit {} {

  set position [Tool_ExitGeom]
  set res [VShowWindow.ascConfirm "240x50$position" "Exit"]
  if {$res == 1} {
    Tool_exit_internal
  }
}
#
# proc Tool_exit_internal {}
#------------------------------------------------------------------------
# the exit/confirm button actions
#------------------------------------------------------------------------
proc Tool_exit_internal {} {

  catch {Solve_do_Flush}
  catch {ExitProbe}
  catch {ExitLibrary}
  catch {ExitUnits}
  ExitIVP
  destroy .
  catch {user_shutdown}
}
