# startup tcl code for ASCEND called via the .ascendrc sourced in the binary
# (C) Ben Allan, Kirk Abbott 1994
# $Revision: 1.25 $
# Date last modified $Date: 97/06/23 20:22:09 $
# ascend.tclId $Id: ascend.tcl,v 1.25 97/06/23 20:22:09 ballan Exp $
# Global init file for windows configurations, button configurations, var inits
# assumes toplevel windows have  not  already been created
#
# all procedures called at the bottom.
#

proc AscGnuButton {} {
  global env
  # pack widget .
  wm positionfrom . user
  wm geometry . 1x1
  wm sizefrom . ""
  wm iconname . "Ascend IV Information"
  wm protocol . WM_DELETE_WINDOW {EXIT}
  wm title . {Ascend IV}
  wm withdraw .
}

proc Help {{arg1 ""} args} {
  if {[catch {set foo [help "$arg1"]} msg]} {
    puts stdout $msg
  } else {
    foreach i $foo {
      puts stdout "$i"
    }
  }
}

proc load_Templates {} {
  global env
  puts "loading templates from $env(ASCENDTK)/templates/"
  puts "source $env(ASCENDTK)/templates/AscMonoEntry1.t"
  source "$env(ASCENDTK)/templates/AscMonoEntry1.t"
  puts "source $env(ASCENDTK)/templates/AscMonoEntry2.t"
  source "$env(ASCENDTK)/templates/AscMonoEntry2.t"
  puts "source $env(ASCENDTK)/templates/AscMonoEntry4.t"
  source "$env(ASCENDTK)/templates/AscMonoEntry4.t"
  puts "source $env(ASCENDTK)/templates/AscConfirm.t"
  source "$env(ASCENDTK)/templates/AscConfirm.t"
  puts "source $env(ASCENDTK)/templates/ascfontsel.tcl"
  source "$env(ASCENDTK)/templates/ascfontsel.tcl"
  puts "source $env(ASCENDTK)/templates/ascparm.tcl"
  source "$env(ASCENDTK)/templates/ascparm.tcl"
  puts "source $env(ASCENDTK)/templates/ascKeepOnTop.tcl"
  source "$env(ASCENDTK)/templates/ascKeepOnTop.tcl"
  puts "source $env(ASCENDTK)/templates/ascListSelect.tcl"
  source "$env(ASCENDTK)/templates/ascListSelect.tcl"
  puts "source $env(ASCENDTK)/templates/ascListSelectB1.tcl"
  source "$env(ASCENDTK)/templates/ascListSelectB1.tcl"
  global tcl_platform
  if {$tcl_platform(platform) == "unix"} {
    puts "source $env(ASCENDTK)/templates/asctkfbox.tcl"
    source "$env(ASCENDTK)/templates/asctkfbox.tcl"
  }
  puts "source $env(ASCENDTK)/templates/ascMsgBox.tcl"
  source "$env(ASCENDTK)/templates/ascMsgBox.tcl"
  puts "source $env(ASCENDTK)/ascplotproc.tcl"
  source "$env(ASCENDTK)/ascplotproc.tcl"
  puts "source $env(ASCENDTK)/ascplot.tcl"
  source "$env(ASCENDTK)/ascplot.tcl"
}


#  Create a temporary EXIT command so that if something goes
#  wrong during startup, we can still exit the application.
#  If startup goes well, this EXIT will be overwritten by the
#  one in ScriptProc.tcl
#
if {[info command EXIT] == ""} {
  proc EXIT {args} {
    catch {destroy .}
    catch {user_shutdown}
    return;
  }
}


global env
AscGnuButton


#stuff that has to be set before windows are shown goes in set_global_defaults
# which is in GlobalProc.tcl.
# i.e. flags that check for whether features are available that are used
#  determine button states, or toplevel existences.
#
# load delayed window instantiation code [ proc awin ] is in GlobalProc too

puts "source $env(ASCENDTK)/GlobalProc.tcl"
source "$env(ASCENDTK)/GlobalProc.tcl"
set_Global_Defaults
Glob_do_GNU

# main sources the window definitions
# main also sources some needed templates in generalk.tcl
puts "source $env(ASCENDTK)/main.tcl"
source "$env(ASCENDTK)/main.tcl"

puts "tk sourced"


# The plot window and the solver window require the
# TkTable exension package by Roland King
if {[catch {package require Tktable 1.3} err]} {
  error "ASCEND cannot locate the tkTable package.\ninternal message: $err"
}


# load separate templates for transient toplevels
# must be done before buttons using those templates are wired via
# global variable vectors
###puts "NOT LOADING TEMPLATES"
load_Templates
puts "templates loaded"

# configure swiped widgets: set_Template_defaults
# routine is in GlobalProc.tcl
set_Template_defaults

# Load button smarts files. Each file is responsible for checking
# existence of its needed global variables (i.e. do the
# initialization of things at the top of the *Proc.tcl
global ascGlobalVect
 # puts "[info commands awin] w_load = $ascGlobalVect(w_load)"
#
 # Switch to determine whether to load all the windows or no.
if {$ascGlobalVect(w_load)} {
  puts "All windows will be loaded"
  awin all
} {
  puts "Nowindows will be loaded"
}
# load in .ascend-config
puts "Reading utilities"
Util_do_Read
puts stdout "Interface Loaded."

# try to straighten out iconnames
asc_fixiconnames

# bind help to buttons
#>>Help_BindAllM3


