# Module: batest.tcl
# Tcl version: 7.1 (Tcl/Tk/XF)
# Tk version: 3.4
# XF version: 2.2
#

# module contents
global moduleList
global autoLoadList
set moduleList(batest.tcl) { envVal loadAppDefaults showVars}
set autoLoadList(batest.tcl) {0}

source templates/ascDoubleE.tcl

# procedures to show toplevel windows


# User defined procedures


# Procedure: envVal
proc envVal { envValName} {
  global env
  if [info exists env($envValName)] {return $env($envValName)} {return {}}
}


# Procedure: loadAppDefaults
proc loadAppDefaults { classNameList {priority "startupFile"}} {
  set filepath "[split [envVal XUSERFILESEARCHPATH] :]  [envVal XAPPLRESDIR]                 [split [envVal XFILESEARCHPATH] :]     /usr/lib/X11"
  foreach i $classNameList {
    foreach j $filepath {
      if {[file exists $j/$i]} {
        option readfile $j/$i $priority; break
      }
    }
  }
}


# Procedure: showVars
proc showVars { w args} {
  catch {destroy $w}
  toplevel $w
  wm title $w "Variable values"
  label $w.title \
    -text "Variable values:" \
    -width 20 \
    -anchor center \
    -font {helvetica 18 bold}
  pack append $w $w.title {top fillx}
  foreach i $args {
    frame $w.$i
    label $w.$i.name -text "$i: "
    label $w.$i.value -textvar $i
    pack append $w.$i $w.$i.name left $w.$i.value left
    pack append $w $w.$i {top frame w}
  }
  button $w.ok -text OK -command "destroy $w"
  pack append $w $w.ok {bottom pady 2}
}


set ascSimsVect(target_instance) ""
set ascSimsVect(instancetype) ""

#
# proc browinquireCreatePart (create part button on the browser)
#
proc browinquireCreatePart {} {
  global entryLDouble
  set $entryLDouble(line1) "fred1"
  set $entryLDouble(line2) "fred2"
  EntryLDouble "Create Part:" "Part Name:" " Part Type:" \
      "browCreatePart" \
      "" "browCreatePartHelp" "315x70" \
      "browValidPart" "browCreatePartError"
}
#
# proc browCreatePart
#
proc browCreatePart {} {
  global entryLDouble
  createpart $entryLDouble(line1) $entryLDouble(line2)
}
#
# check valid name and type for user part specification
#
proc browValidPart {} {
  global entryLDouble
  if {!([typeexist $entryLDouble(line2)])} {
    return 0
  }
  if {[childexist $entryLDouble(line1)]} {
    return 0
  }
  return 1
}
#
# input error messages
#
  proc browCreatePartError {} {
    global entryLDouble
    if {![typeexist $entryLDouble(line2)]} {
      AlertBox "CreatePart: type $entryLDouble(line2) unknown" \
             "" [expr 180+[string length $entryLDouble(line2)]*9]x45 \
             "Error" OK
      return}
    if {[childexist $entryLDouble(line1)]} {
      AlertBox "CreatePart: name $entryLDouble(line1) exists" \
             "" [expr 180+[string length $entryLDouble(line1)]*9]x45 \
             "Error" OK
      return}
    return
  }
#
# help
#
  proc browCreatePartHelp {} {
    AlertBox "The parent you are adding to must be of an expandable type. NAME must not already be part of the instance. TYPE must be the name of an existing type." \
    "" 350x100 "Help for Browser.Edit.Compile.CreatePart:" OK
    return
  }

# dummy funcs
# proc childexist {a} {return 1}
# proc typeexist {a} {return 1}
# proc createpart {a b} {return}
set entryLDouble(line1) ""
set entryLDouble(line2) ""
