# Module: browser.tcl
# Tcl version: 7.1 (Tcl/Tk/XF)
# Tk version: 3.4
# XF version: 2.2
# (C) Kirk Abbott, Ben Allan  1994
# $Revision: 1.31 $
# $Date: 97/09/22 16:35:35 $
#

# module contents
global moduleList
global autoLoadList
set moduleList(browser.tcl) { .browser}
set autoLoadList(browser.tcl) {0}

# procedures to show toplevel windows


# procedure to show window ShowWindow.browser
proc ShowWindow.browser { args} { # xf ignore me 7

  global ascBrowVect ascGlobalVect
StartupSrc.browser

  # build widget .browser
  if {"[info procs XFEdit]" != ""} {
    catch "XFDestroy .browser"
  } {
    catch "destroy .browser"
  }
  toplevel .browser

  # Window manager configurations
  wm iconify .browser
  wm positionfrom .browser user
  wm sizefrom .browser user
  wm iconname .browser {Browser}
  wm minsize .browser 100 100
  wm title .browser {ASCEND Browser}
  wm protocol .browser WM_DELETE_WINDOW {Toggle_Remote ascBrowVect}


  # build widget .browser.main_frm
  frame .browser.main_frm

  # build widget .browser.main_frm.child_box
  frame .browser.main_frm.child_box

  # build widget .browser.main_frm.child_box.scrollbar2
  scrollbar .browser.main_frm.child_box.scrollbar2 \
    -command {.browser.main_frm.child_box.listbox1 yview}

  # build widget .browser.main_frm.child_box.scrollbar3
  scrollbar .browser.main_frm.child_box.scrollbar3 \
    -command {.browser.main_frm.child_box.listbox1 xview} \
    -orient {horizontal}

  # build widget .browser.main_frm.child_box.listbox1
  listbox .browser.main_frm.child_box.listbox1 \
    -relief {raised} \
    -xscrollcommand {.browser.main_frm.child_box.scrollbar3 set} \
    -yscrollcommand {.browser.main_frm.child_box.scrollbar2 set} \
    -font $ascBrowVect(font) \
    -width 18 \
    -height 2 \
    -exportselection 0


  # pack widget .browser.main_frm.child_box
  pack append .browser.main_frm.child_box \
    .browser.main_frm.child_box.scrollbar2 {right frame center filly} \
    .browser.main_frm.child_box.listbox1 {top frame center expand fill} \
    .browser.main_frm.child_box.scrollbar3 {bottom frame center fillx}

  # build widget .browser.main_frm.parents_box
  frame .browser.main_frm.parents_box

  # build widget .browser.main_frm.parents_box.scrollbar2
  scrollbar .browser.main_frm.parents_box.scrollbar2 \
    -command {.browser.main_frm.parents_box.listbox1 yview}

  # build widget .browser.main_frm.parents_box.scrollbar3
  scrollbar .browser.main_frm.parents_box.scrollbar3 \
    -command {.browser.main_frm.parents_box.listbox1 xview} \
    -orient {horizontal}

  # build widget .browser.main_frm.parents_box.listbox1
  listbox .browser.main_frm.parents_box.listbox1\
    -relief {raised} \
    -xscrollcommand {.browser.main_frm.parents_box.scrollbar3 set} \
    -yscrollcommand {.browser.main_frm.parents_box.scrollbar2 set} \
    -font $ascBrowVect(font) \
    -width 12 \
    -height 2

  # pack widget .browser.main_frm.parents_box
  pack append .browser.main_frm.parents_box \
      .browser.main_frm.parents_box.scrollbar2 {left frame center filly} \
      .browser.main_frm.parents_box.listbox1 {top frame center expand fill} \
      .browser.main_frm.parents_box.scrollbar3 {bottom frame center fillx}

  # pack widget .browser.main_frm
  pack append .browser.main_frm \
      .browser.main_frm.parents_box {left frame center filly} \
      .browser.main_frm.child_box {left frame center expand fill}


  # build widget .browser.local_frm
  frame .browser.local_frm

  # build widget .browser.local_frm.child_box
  frame .browser.local_frm.child_box

  # build widget .browser.local_frm.child_box.scrollbar2
  scrollbar .browser.local_frm.child_box.scrollbar2 \
    -command {.browser.local_frm.child_box.listbox1 yview}

  # build widget .browser.local_frm.child_box.scrollbar3
  scrollbar .browser.local_frm.child_box.scrollbar3 \
    -command {.browser.local_frm.child_box.listbox1 xview} \
    -orient {horizontal}

  # build widget .browser.local_frm.child_box.listbox1
  listbox .browser.local_frm.child_box.listbox1 \
    -relief {raised} \
    -xscrollcommand {.browser.local_frm.child_box.scrollbar3 set} \
    -yscrollcommand {.browser.local_frm.child_box.scrollbar2 set} \
    -font $ascBrowVect(font) \
    -width 18 \
    -height 2 \
    -exportselection 0


  # pack widget .browser.local_frm.child_box
  pack append .browser.local_frm.child_box \
    .browser.local_frm.child_box.scrollbar2 {right frame center filly} \
    .browser.local_frm.child_box.listbox1 {top frame center expand fill} \
    .browser.local_frm.child_box.scrollbar3 {bottom frame center fillx}

  # build widget .browser.local_frm.check_box
  frame .browser.local_frm.check_box
  
  set rr .browser.local_frm.check_box

  # The command option of these checkbuttons is ugly.
  # should instead of passing an arg, just use the traces
  # on ascBrowVect(localshow,*) to set a (lasttoggled) value
  # so that Brow_do_UpdateLocalBox doesn't need an argument.

  # build rr.b1
  checkbutton $rr.b1 \
    -variable ascBrowVect(localshow,REAL_ATOM_INST) \
    -command {Brow_do_UpdateLocalBox REAL_ATOM_INST} \
    -text RV 

  # build rr.b2
  checkbutton $rr.b2 \
    -variable ascBrowVect(localshow,INTEGER_ATOM_INST) \
    -command {Brow_do_UpdateLocalBox INTEGER_ATOM_INST} \
    -text DV

  # build rr.b3
  checkbutton $rr.b3 \
    -variable ascBrowVect(localshow,REL_INST) \
    -command {Brow_do_UpdateLocalBox REL_INST} \
    -text RR

  # build rr.b4
  checkbutton $rr.b4 \
    -variable ascBrowVect(localshow,LREL_INST) \
    -command {Brow_do_UpdateLocalBox LREL_INST} \
    -text LR

  # build rr.b5
  checkbutton $rr.b5 \
    -variable ascBrowVect(localshow,REAL_CONSTANT_INST) \
    -command {Brow_do_UpdateLocalBox REAL_CONSTANT_INST} \
    -text RC

  # build rr.b6
  checkbutton $rr.b6 \
    -variable ascBrowVect(localshow,SET_ATOM_INST) \
    -command {Brow_do_UpdateLocalBox SET_ATOM_INST} \
    -text DC 

  # build rr.label
  label $rr.label \
    -textvariable ascBrowVect(locallabel) \
    -justify right

  # pack widget .browser.local_frm.check_box
  pack append .browser.local_frm.check_box \
      $rr.b1 {left frame center fill} \
      $rr.b2 {left frame center fill} \
      $rr.b3 {left frame center fill} \
      $rr.b4 {left frame center fill} \
      $rr.b5 {left frame center fill} \
      $rr.b6 {left frame center fill} \
      $rr.label {left frame center expand fill}

  # pack widget .browser.main_frm
  pack append .browser.local_frm \
      .browser.local_frm.child_box {top frame center expand fill} \
      .browser.local_frm.check_box {top frame center fill}

  #
  # Build the menu bar and submenus
  #
  menu .browser.menubar \
    -tearoffcommand .BROWSER.MENUBAR \
    -tearoff 0

  # The Display menu
  menu .browser.menubar.display \
    -tearoffcommand .BROWSER.MENUBAR.DISPLAY \
    -tearoff 0
  .browser.menubar.display add command  \
    -command {Brow_do_DispAttr} \
    -label {Attributes} \
    -underline 0
  .browser.menubar.display add command  \
    -command {Brow_do_DispRelations} \
    -label {Relations} \
    -underline 0
  .browser.menubar.display add command  \
    -command {Brow_do_DispCondRels} \
    -label {Cond Rels} \
    -underline 0
  .browser.menubar.display add command  \
    -command {Brow_do_DispLogRels} \
    -label {Log Rels} \
    -underline 0
  .browser.menubar.display add command  \
    -command {Brow_do_DispCondLogRels} \
    -label {Cond Log Rels} \
    -underline 1
  .browser.menubar.display add command  \
    -command {Brow_do_DispWhens} \
    -label {Whens} \
    -underline 0
  .browser.menubar.display add separator
  .browser.menubar.display add command  \
    -command {Brow_do_Plot} \
    -label {Plot} \
    -underline 0
  .browser.menubar.display add command  \
    -command {Brow_do_Statistics} \
    -label {Statistics} \
    -underline 0

  # The File menu
  menu .browser.menubar.file \
    -tearoffcommand .BROWSER.MENUBAR.FILE \
    -tearoff 0
  .browser.menubar.file add separator
  .browser.menubar.file add command  \
    -command {Toggle_Remote ascBrowVect} \
    -label {Close window} \
    -underline 0
  .browser.menubar.file add command  \
    -command {Script_do_Exit} \
    -label {Exit ASCEND...} \
    -underline 0

  # The Edit menu
  menu .browser.menubar.edit \
    -tearoffcommand .BROWSER.MENUBAR.EDIT \
    -tearoff 0
  .browser.menubar.edit add command  \
    -command {Browser_do_Methods} \
    -label {Run method...} \
    -underline 1
  .browser.menubar.edit add command  \
    -command {Browser_do_ClearVars}  \
    -label {Clear Vars} \
    -underline 0
  .browser.menubar.edit add separator
  .browser.menubar.edit add command \
    -command {Browser_do_SetValue} \
    -label {Set value...} \
    -underline 0
  .browser.menubar.edit add command \
    -command {Brow_do_Write} \
    -label {Write values...} \
    -underline 0
  .browser.menubar.edit add command \
    -command {Brow_do_Read} \
    -label {Read values...} \
    -underline 1
  .browser.menubar.edit add command \
    -command {Browser_do_Refine} \
    -label {Refine...} \
    -underline 0
  .browser.menubar.edit add command \
    -command {Browser_do_Merge} \
    -label {Merge...} \
    -underline 0
  .browser.menubar.edit add separator
  .browser.menubar.edit add cascade \
    -label {Compile} \
    -menu {.browser.menubar.edit.compile}

  # build widget .browser.menubar.edit.compile
  menu .browser.menubar.edit.compile \
    -tearoffcommand .BROWSER.MENUBAR.EDIT.COMPILE \
    -tearoff 0
  .browser.menubar.edit.compile add command \
    -command {Browser_do_Resume} \
    -label {Resume Compilation}
  .browser.menubar.edit.compile add command \
    -command {Browser_do_CreatePart}  \
    -label {Create Part} \
    -state disabled


  # The Export menu
  menu .browser.menubar.export \
    -tearoffcommand .BROWSER.MENUBAR.EXPORT \
    -tearoff 0
  .browser.menubar.export add command \
    -command {Brow_do_Export2Solver} \
    -label {to Solver} \
    -underline 3
  .browser.menubar.export add command \
    -command {Brow_do_Export2Probe} \
    -label {Many to Probe ...} \
    -underline 0
  .browser.menubar.export add command \
    -command {Brow_do_ExportOne2Probe} \
    -label {Item to Probe} \
    -underline 8


  # The Find menu
  menu .browser.menubar.find \
    -tearoffcommand .BROWSER.MENUBAR.FIND \
    -tearoff 0
  .browser.menubar.find add command \
    -command {Brow_do_FindbyName} \
    -label {By name...} \
    -underline 3
  .browser.menubar.find add command \
    -command {Brow_do_FindbyType} \
    -label {By type...} \
    -underline 3
  .browser.menubar.find add command \
    -command {Brow_do_FindAliases} \
    -label {Aliases} \
    -underline 0
  .browser.menubar.find add command \
    -command {Brow_do_FindISAs} \
    -label {Where created} \
    -underline 0
  .browser.menubar.find add command \
    -command {Brow_do_FindClique} \
    -label {Clique} \
    -underline 0
  .browser.menubar.find add command \
    -command {Brow_do_FindEligible} \
    -label {Eligible variables} \
    -underline 0
  .browser.menubar.find add command \
    -command {Brow_do_FindOpers} \
    -label {Operands} \
    -underline 0
  .browser.menubar.find add command \
    -command {Brow_do_FindParents} \
    -label {Parents} \
    -underline 0
  .browser.menubar.find add command \
    -command {Brow_do_FindPendings} \
    -label {Pendings} \
    -underline 3


  # The Help menu
  menu .browser.menubar.help \
    -tearoffcommand .BROWSER.MENUBAR.HELP \
    -tearoff 0
  .browser.menubar.help add command \
    -command {Brow_do_Help} \
    -label {On Browser} \
    -underline 3


  # The View menu
  menu .browser.menubar.view \
    -tearoffcommand .BROWSER.MENUBAR.VIEW \
    -tearoff 0
  .browser.menubar.view add checkbutton \
    -command {Brow_do_TypeorValue} \
    -offvalue ATOMS \
    -onvalue {} \
    -variable {ascBrowVect(ShowAtoms)} \
    -label {Suppress atoms}
  .browser.menubar.view add checkbutton \
    -command {Brow_do_TypeorValue} \
    -offvalue {TYPE} \
    -onvalue {VALUE} \
    -variable {ascBrowVect(TypeorValue)} \
    -label {Display Atom Values}
  .browser.menubar.view add checkbutton \
    -offvalue {0} \
    -onvalue {1} \
    -variable {ascBrowVect(dimconsistency)} \
    -label {Check dimensionality}
  .browser.menubar.view add command \
    -command {Brow_do_HideNames} \
    -label {Hide names...} \
    -underline 0
  .browser.menubar.view add command \
    -command {Brow_do_UnHideNames} \
    -label {Unhide names...} \
    -underline 0
  .browser.menubar.view add separator
  .browser.menubar.view add command  \
    -command {Brow_do_Font}  \
    -label {Font ...} \
    -underline 0
  .browser.menubar.view add checkbutton \
    -offvalue {0} \
    -onvalue {1} \
    -variable {ascBrowVect(visibility)} \
    -label {Open automatically} \
    -underline 0

  #
  # Add the menus as cascades of the toplevel's menu;
  # add the toplevel's menu to the toplevel
  #
  .browser.menubar add cascade \
    -menu .browser.menubar.file \
    -label {File} \
    -underline 0
  .browser.menubar add cascade \
    -menu .browser.menubar.edit \
    -label {Edit} \
    -underline 0
  .browser.menubar add cascade \
    -menu .browser.menubar.display \
    -label {Display} \
    -underline 0
  .browser.menubar add cascade \
    -menu .browser.menubar.find \
    -label {Find} \
    -underline 1
  .browser.menubar add cascade \
    -menu .browser.menubar.view \
    -label {View} \
    -underline 0
  .browser.menubar add cascade \
    -menu .browser.menubar.export \
    -label {Export} \
    -underline 1
  .browser.menubar add cascade \
    -menu .browser.menubar.help \
    -label {Help} \
    -underline 0
  .browser configure \
    -menu .browser.menubar


  #
  #  Add the main frame to the browser toplevel
  #
  pack append .browser \
    .browser.main_frm {top frame center expand fill} \
    .browser.local_frm {top frame center expand fill}

  EndSrc.browser

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree .browser"
    after 2 "catch {XFEditSetShowWindows}"
  }
}

# proc DestroyWindow.browser {}
proc DestroyWindow.browser {} {# xf ignore me 7
  if {"[info procs XFEdit]" != ""} {
    if {"[info commands .browser]" != ""} {
      global xfShowWindow.browser
      set xfShowWindow.browser 0
      XFEditSetPath .
      after 2 "XFSaveAsProc .browser; XFEditSetShowWindows"
    }
  } {
    catch "destroy .browser"
    update
  }
}

# proc StartupSrc.browser {args}
proc StartupSrc.browser {args} {
 # browser startup entrance
  global ascBrowVect ascGlobalVect env
  if {[catch {set ascBrowVect(windowname)} ]} {
    set ascBrowVect(minsize) 100x100
    set ascBrowVect(geometry) 200x400+10+10
    set ascBrowVect(iconname) Browser
    set ascBrowVect(initialstate) normal
    set ascBrowVect(font) "-*-*"
  }
  if {[catch {set ascGlobalVect(font)} ]} {
    set ascGlobalVect(font) "-*-*"
    set ascGlobalVect(labelfont) "-*-*"
    set ascGlobalVect(tbg) "white"
    set ascGlobalVect(tfg) "black"
    set ascGlobalVect(bg) "white"
    set ascGlobalVect(fg) "black"
    set ascGlobalVect(afg) "white"
    set ascGlobalVect(abg) "black"
    set ascGlobalVect(sfg) "white"
    set ascGlobalVect(sbg) "black"
    set ascGlobalVect(visibility) 1
    set ascGlobalVect(c_loaded) "0"
    set ascGlobalVect(toolbitmap) \
      "@$env(ASCENDBITMAPS)/toolAttributes.xbm"
  }
}

# proc EndSrc.browser {}
proc EndSrc.browser {} {
 # browser startup exit
  global ascBrowVect
  set minw [lindex [split $ascBrowVect(minsize) x] 0]
  set minh [lindex [split $ascBrowVect(minsize) x] 1]
  set gw [lindex [split [lindex [split $ascBrowVect(geometry) +] 0] x] 0]
  set gh [lindex [split [lindex [split $ascBrowVect(geometry) +] 0] x] 1]
  set gp "+[lindex [split [split $ascBrowVect(geometry) x] +] 1]+[lindex [split [split $ascBrowVect(geometry) x] +] 2]"
  if {[expr $gw < $minw]} {set gw $minw}
  if {[expr $gh < $minh]} {set gh $minh}
  set gwh "${gw}x${gh}"
  wm minsize .browser $minw $minh
  wm geometry .browser [osgpos $gwh$gp]
  wm iconname .browser $ascBrowVect(iconname)

  if {$ascBrowVect(initialstate)!="iconic" && \
      $ascBrowVect(initialstate)!="iconified" &&
      $ascBrowVect(initialstate)!="withdrawn"} {
    wm deiconify .browser
  }
  if {"$ascBrowVect(initialstate)"=="withdrawn"} {
    wm withdraw .browser
  }
}

# User defined procedures
 # repeated here for standalone use. main definition is in generalk.tcl
proc osgpos {geom} {
  set sh [winfo screenheight .]; set sw [winfo screenwidth .]
  set glist [split $geom +-]
  if {[llength $glist] != 3} {error "Invalid geometry spec passed to osg"}
  set x [lindex $glist 1] ; set y [lindex $glist 2]
  set slist [split [lindex $glist 0] x]
  if {[llength $slist] != 2} {error "Invalid window size given to osg"}
  set w [lindex $slist 0] ; set h [lindex $slist 1]
  set newx $x ; set newy $y
  if {($x + $w) > $sw} {set newx [expr $sw - $w]}
  if {($y + $h) > $sh} {set newy [expr $sh - $h -20]}
  if { $newx < 2 } {set newx 2} ; if { $newy < 2 } {set newy 2}
  return [lindex $glist 0]+$newx+$newy
}
proc setpos {master {offsetx "70"} {offsety "70"}} {# calculates offsets
  set xpos [expr [winfo rootx $master] + $offsetx]
  set ypos [expr [winfo rooty $master] + $offsety]
  return "+$xpos+$ypos"
}


# Internal procedures

# eof
#
