# Module: library.tcl
# Tcl version: 7.1 (Tcl/Tk/XF)
# Tk version: 3.4
# XF version: 2.2
# (C) 1994 Kirk Abbott, Ben Allan
# $Revision: 1.15 $
# $Date: 97/09/22 16:35:40 $
#

# module contents
global moduleList
global autoLoadList
set moduleList(library.tcl) {.library}
set autoLoadList(library.tcl) {0}

# procedures to show toplevel windows


# procedure to show window ShowWindow.library
# proc ShowWindow.library { args}
proc ShowWindow.library { args} {
  # xf ignore me 7

  global env ascGlobalVect ascLibrVect
  StartupSrc.library

  # build widget .library
  if {"[info procs XFEdit]" != ""} {
    catch "XFDestroy .library"
  } {
    catch "destroy .library"
  }
  toplevel .library

  # Ascend patched window manager configurations
  wm iconify .library
  wm positionfrom .library user
  wm sizefrom .library user
  wm iconname .library {Library}
  wm minsize .library 100 100
  wm title .library {ASCEND Library}
  wm protocol .library WM_DELETE_WINDOW {Toggle_Remote ascLibrVect}

  # build widget .library.main_frm
  frame .library.main_frm \
    -borderwidth 0

  # build widget .library.main_frm.file_box
  frame .library.main_frm.file_box

  # build widget .library.main_frm.file_box.scrollbar2
  scrollbar .library.main_frm.file_box.scrollbar2 \
    -command {.library.main_frm.file_box.listbox1 yview}

  # build widget .library.main_frm.file_box.listbox1
  listbox .library.main_frm.file_box.listbox1 \
    -relief {raised} \
    -yscrollcommand {.library.main_frm.file_box.scrollbar2 set} \
    -font $ascLibrVect(font) \
    -exportselection 0 \
    -width 20 \
    -height 2

  # pack widget .library.main_frm.file_box
  pack append .library.main_frm.file_box \
    .library.main_frm.file_box.scrollbar2 {left frame center filly} \
    .library.main_frm.file_box.listbox1 {top frame center expand fill}

  # build widget .library.main_frm.model_box
  frame .library.main_frm.model_box

  # build widget .library.main_frm.model_box.scrollbar2
  scrollbar .library.main_frm.model_box.scrollbar2 \
    -command {.library.main_frm.model_box.listbox1 yview}

  # build widget .library.main_frm.model_box.listbox1
  listbox .library.main_frm.model_box.listbox1 \
    -relief {raised} \
    -yscrollcommand {.library.main_frm.model_box.scrollbar2 set} \
    -font $ascLibrVect(font) \
    -exportselection 0 \
    -width 8 \
    -height 2

  # pack widget .library.main_frm.model_box
  pack append .library.main_frm.model_box \
    .library.main_frm.model_box.scrollbar2 {right frame center filly} \
    .library.main_frm.model_box.listbox1 {top frame center expand fill}

  # pack widget .library.main_frm
  pack append .library.main_frm \
    .library.main_frm.file_box {left frame center fill} \
    .library.main_frm.model_box {left frame center expand fill}


  #
  #  Build the entry box
  #
  frame .library.entry_frm \
    -borderwidth {0} \
    -relief {raised}

  entry .library.entry_frm.lib_entry \
    -relief {raised} \
    -width {24} \
    -textvariable ascLibrVect(entryline) \
    -font $ascLibrVect(entryFont) \
    -exportselection 0 \
    -cursor hand2

  # pack widget .library.entry_frm
  pack append .library.entry_frm \
    .library.entry_frm.lib_entry {left frame w pady 5 expand fill}


  #
  # Build the scrollable listbox to hold the simulation names
  #
  frame .library.sims_frm \
    -borderwidth {0}
  frame .library.sims_frm.sims_box \
    -borderwidth {0}

  # pack widget .library.sims_frm
  pack append .library.sims_frm \
    .library.sims_frm.sims_box {left frame center expand fill}

  # build widget .library.sims_frm.sims_box.listbox1
  listbox .library.sims_frm.sims_box.listbox1 \
    -relief {raised} \
    -xscrollcommand {.library.sims_frm.sims_box.scrollbar3 set} \
    -yscrollcommand {.library.sims_frm.sims_box.scrollbar2 set} \
    -font $ascLibrVect(font) \
    -exportselection 0 \
    -width 1 \
    -height 3

  # build widget .library.sims_frm.sims_box.scrollbar2
  scrollbar .library.sims_frm.sims_box.scrollbar2 \
    -command {.library.sims_frm.sims_box.listbox1 yview}

  # build widget .library.sims_frm.sims_box.scrollbar3
  scrollbar .library.sims_frm.sims_box.scrollbar3 \
    -command {.library.sims_frm.sims_box.listbox1 xview} \
    -orient {horizontal}

  # pack widget .library.sims_frm.sims_box
  pack append .library.sims_frm.sims_box \
    .library.sims_frm.sims_box.scrollbar2 {right frame center filly} \
    .library.sims_frm.sims_box.listbox1 {top frame center expand fill} \
    .library.sims_frm.sims_box.scrollbar3 {bottom frame center fillx}


  #
  # Build the menu bar and submenus
  #
  menu .library.menubar \
    -tearoffcommand .LIBRARY.MENUBAR \
    -tearoff 0

  # The Display menu
  menu .library.menubar.display \
    -tearoffcommand .LIBRARY.MENUBAR.DISPLAY \
    -tearoff 0
  .library.menubar.display add command \
    -command {Disp_do_ShowCode} \
    -label {Code} \
    -underline 0
  .library.menubar.display add command \
    -command {Disp_do_ShowAncestry} \
    -label {Ancestry} \
    -underline 0
  .library.menubar.display add command \
    -command {Disp_do_Hierarchy} \
    -label {Refinement hierarchy} \
    -underline 0
  .library.menubar.display add command \
    -command {Disp_do_PrintExtFuncLibrary} \
    -label {External functions} \
    -underline 0
  .library.menubar.display add cascade \
    -menu .library.menubar.display.hide \
    -label {Hide type} \
    -underline 0
  .library.menubar.display add cascade \
    -menu .library.menubar.display.unhide \
    -label {UnHide type} \
    -underline 0
  .library.menubar.display add command \
    -command {Libr_do_Hide_Fundamentals} \
    -label {Hide/Show Fundamentals...} \
    -underline 10

  # The Hide menu under the Display menu
  menu .library.menubar.display.hide \
    -tearoffcommand .LIBRARY.MENUBAR.DISPLAY.HIDE \
    -tearoff 0
  .library.menubar.display.hide add command \
     -command {Libr_do_Hide_Type} \
     -label {Hide selected type}
  .library.menubar.display.hide add command \
     -command {Libr_do_Hide_Type_Refinements} \
     -label {Hide type and its refinements}

  # The UnHide menu under the Display menu
  menu .library.menubar.display.unhide \
    -tearoffcommand .LIBRARY.MENUBAR.DISPLAY.UNHIDE \
    -tearoff 0
  .library.menubar.display.unhide add command \
     -command {Libr_do_UnHide_Type} \
     -label {UnHide selected type}
  .library.menubar.display.unhide add command \
     -command {Libr_do_UnHide_Type_Refinements} \
     -label {UnHide type and its refinements}


  # The Edit menu
  menu .library.menubar.edit \
    -tearoffcommand .LIBRARY.MENUBAR.EDIT \
    -tearoff 0
  .library.menubar.edit add command \
    -command {Libr_do_compile} \
    -label {Create simulation...} \
    -underline 0
  .library.menubar.edit add separator
  .library.menubar.edit add command  \
    -command {Sims_do_Delete} \
    -label {Delete simulation...} \
    -underline 7
  .library.menubar.edit add command \
    -command {Libr_do_DeleteAll} \
    -label {Delete all types...} \
    -underline 11


  # The Export menu
  menu .library.menubar.export \
    -tearoffcommand .LIBRARY.MENUBAR.EXPORT \
    -tearoff 0
  .library.menubar.export add command \
    -command {Sims_do_Export2Browser} \
    -label {Simulation to Browser} \
    -underline 14
  .library.menubar.export add command \
    -command {Sims_do_Export2Solver} \
    -label {Simulation to Solver} \
    -underline 14
  .library.menubar.export add command \
    -command {Sims_do_Export2Probe} \
    -label {Simulation to Probe} \
    -underline 14


  # The File menu
  menu .library.menubar.file \
    -tearoffcommand .LIBRARY.MENUBAR.FILE \
    -tearoff 0
  .library.menubar.file add command \
    -command {Libr_do_read} \
    -label {Read types from file...} \
    -underline 5
  .library.menubar.file add separator
  .library.menubar.file add command \
    -command {Toggle_Remote ascLibrVect} \
    -label {Close window} \
    -underline 0
  .library.menubar.file add command \
    -command {Script_do_Exit} \
    -label {Exit ASCEND...} \
    -underline 0


  # The Find menu
  menu .library.menubar.find \
    -tearoffcommand .LIBRARY.MENUBAR.FIND \
    -tearoff 0
  .library.menubar.find add command \
    -command {Libr_do_FindType} \
    -label {Type by name...} \
    -underline 0
  .library.menubar.find add command \
    -command {Libr_do_FindFuzzy} \
    -label {Type by fuzzy name...} \
    -underline 8
  .library.menubar.find add cascade \
    -menu .library.menubar.find.pendings \
    -label {Pending statements} \
    -underline 0

  # The Pendings submenu under the Find menu
  menu .library.menubar.find.pendings \
    -tearoffcommand .LIBRARY.MENUBAR.FIND.PENDINGS \
    -tearoff 0
  .library.menubar.find.pendings add command  \
    -command {Disp_do_ShowPendings} \
    -label {To Display} \
    -underline 3
  .library.menubar.find.pendings add command  \
    -command {Sims_Pendings_To_Stdout} \
    -label {To Console} \
    -underline 3
  .library.menubar.find.pendings add command  \
    -command {Sims_Pendings_To_File} \
    -label {To File} \
    -underline 3



  # The Help menu
  menu .library.menubar.help \
    -tearoffcommand .LIBRARY.MENUBAR.HELP \
    -tearoff 0
  .library.menubar.help add command \
    -command {Libr_do_Help} \
    -label {On Library} \
    -underline 3


  # The View menu
  menu .library.menubar.view \
    -tearoffcommand .LIBRARY.MENUBAR.VIEW \
    -tearoff 0
  .library.menubar.view add command  \
    -command {Libr_do_Font}  \
    -label {Font ...} \
    -underline 0
  .library.menubar.view add checkbutton \
    -offvalue {0} \
    -onvalue {1} \
    -variable {ascLibrVect(visibility)} \
    -label {Open automatically} \
    -underline 0


  #
  # Add the menus as cascades of the toplevel's menu;
  # add the toplevel's menu to the toplevel
  #
  .library.menubar add cascade \
    -menu .library.menubar.file \
    -label {File} \
    -underline 0
  .library.menubar add cascade \
    -menu .library.menubar.edit \
    -label {Edit} \
    -underline 0
  .library.menubar add cascade \
    -menu .library.menubar.display \
    -label {Display} \
    -underline 0
  .library.menubar add cascade \
    -menu .library.menubar.find \
    -label {Find} \
    -underline 1
  .library.menubar add cascade \
    -menu .library.menubar.view \
    -label {View} \
    -underline 0
  .library.menubar add cascade \
    -menu .library.menubar.export \
    -label {Export} \
    -underline 1
  .library.menubar add cascade \
    -menu .library.menubar.help \
    -label {Help} \
    -underline 0
  .library configure \
    -menu .library.menubar


  #
  #  Pack the library widget
  #
  pack append .library  \
    .library.main_frm {top frame center expand fill} \
    .library.entry_frm {top frame center fillx} \
    .library.sims_frm {top frame center fillx}

  EndSrc.library

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree .library"
    after 2 "catch {XFEditSetShowWindows}"
  }
}

# proc DestroyWindow.library {}
proc DestroyWindow.library {} {# xf ignore me 7
  if {"[info procs XFEdit]" != ""} {
    if {"[info commands .library]" != ""} {
      global xfShowWindow.library
      set xfShowWindow.library 0
      XFEditSetPath .
      after 2 "XFSaveAsProc .library; XFEditSetShowWindows"
    }
  } {
    catch "destroy .library"
    update
  }
}

# proc StartupSrc.library {args}
proc StartupSrc.library {args} {
# library startup entrance
# as much of the C/global dependencies managed here as possible
  global ascLibrVect ascGlobalVect env
  if {[catch {set ascLibrVect(windowname)} ]} {
    set ascLibrVect(minsize) 100x100
    set ascLibrVect(geometry) 350x350+10+10
    set ascLibrVect(iconname) Library
    set ascLibrVect(initialstate) normal
  }
  if {[catch {set ascGlobalVect(font)} ]} {
    set ascGlobalVect(font) "-*-*"
    set ascGlobalVect(labelfont) "-*-*"
    set ascGlobalVect(tbg) "white"
    set ascGlobalVect(tfg) "black"
    set ascGlobalVect(bg) "white"
    set ascGlobalVect(fg) "black"
    set ascGlobalVect(afg) "white"
    set ascGlobalVect(abg) "black"
    set ascGlobalVect(sfg) "white"
    set ascGlobalVect(sbg) "black"
    set ascGlobalVect(visibility) 1
    set ascGlobalVect(c_loaded) "0"
    set ascGlobalVect(toolbitmap) \
      "@$env(ASCENDBITMAPS)/toolAttributes.xbm"
  }
}

# proc EndSrc.library {}
proc EndSrc.library {} {
# library startup exit
  global ascLibrVect env
  set minw [lindex [split $ascLibrVect(minsize) x] 0]
  set minh [lindex [split $ascLibrVect(minsize) x] 1]
  set gw [lindex [split [lindex [split $ascLibrVect(geometry) +] 0] x] 0]
  set gh [lindex [split [lindex [split $ascLibrVect(geometry) +] 0] x] 1]
  set gp "+[lindex [split [split $ascLibrVect(geometry) x] +] 1]+[lindex [split [split $ascLibrVect(geometry) x] +] 2]"
  if {[expr $gw < $minw]} {set gw $minw}
  if {[expr $gh < $minh]} {set gh $minh}
  set gwh "${gw}x${gh}"
  wm minsize .library $minw $minh
  wm geometry .library [osgpos $gwh$gp]
  wm iconname .library $ascLibrVect(iconname)

  if {$ascLibrVect(initialstate)!="iconic" && \
      $ascLibrVect(initialstate)!="iconified" && \
      $ascLibrVect(initialstate)!="withdrawn"} {
    wm deiconify .library
  }
  if {$ascLibrVect(initialstate)=="withdrawn"} {
    wm withdraw .library
  }
}

# User
 # repeated here for standalone use. main definition is in generalk.tcl
proc osgpos {geom} {
  set sh [winfo screenheight .]; set sw [winfo screenwidth .]
  set glist [split $geom +-]
  if {[llength $glist] != 3} {error "Invalid geometry spec passed to osg"}
  set x [lindex $glist 1] ; set y [lindex $glist 2]
  set slist [split [lindex $glist 0] x]
  if {[llength $slist] != 2} {error "Invalid window size given to osg"}
  set w [lindex $slist 0] ; set h [lindex $slist 1]
  set newx $x ; set newy $y
  if {($x + $w) > $sw} {set newx [expr $sw - $w]}
  if {($y + $h) > $sh} {set newy [expr $sh - $h -20]}
  if { $newx < 2 } {set newx 2} ; if { $newy < 2 } {set newy 2}
  return [lindex $glist 0]+$newx+$newy
}
proc setpos {master {offsetx "70"} {offsety "70"}} {# calculates offsets
  set xpos [expr [winfo rootx $master] + $offsetx]
  set ypos [expr [winfo rooty $master] + $offsety]
  return "+$xpos+$ypos"
}


# eof
#
