# Module: script.tcl
# Tcl version: 7.1 (Tcl/Tk/XF)
# Tk version: 3.4
# XF version: 2.2
# (C) 1994 Kirk Abbott, Ben Allan
# $Revision: 1.25 $
# $Date: 97/06/23 16:29:25 $
#

# module contents
global moduleList
global autoLoadList
set moduleList(script.tcl) { .script}
set autoLoadList(script.tcl) {0}

# procedures to show toplevel windows

#----------------------------
# procedure to show window ShowWindow.script
# proc ShowWindow.script { args}
proc ShowWindow.script { args} {
  # xf ignore me 7
  global ascScripVect ascGlobalVect env

  StartupSrc.script

  # build widget .script
  if {"[info procs XFEdit]" != ""} {
    catch "XFDestroy .script"
  } {
    catch "destroy .script"
  }
  toplevel .script

  #
  # Window manager configurations
  #
  wm positionfrom .script user
  wm sizefrom .script user
  wm iconname .script {Script}
  wm minsize .script 100 100
  wm title .script {ASCEND Script}
  wm protocol .script WM_DELETE_WINDOW {Script_do_Exit}

  #
  # Build frame along bottom of script to hold
  # record button and file name
  #
  frame .script.check_frm \
    -borderwidth {2} \
    -relief {raised}

  entry .script.check_frm.file_entry \
    -relief {raised} \
    -width {24} \
    -textvariable ascScripVect(filename) \
    -font $ascScripVect(font) \
    -state disabled \
    -exportselection 0

  label .script.check_frm.record_btn \
    -text { } \
    -font $ascGlobalVect(font)

  pack append .script.check_frm \
     .script.check_frm.record_btn {left frame center padx 10 pady 6} \
     .script.check_frm.file_entry {left frame w pady 5 expand fill}

  #
  # Build the main frame of the script.  This holds the text boxes.
  #
  frame .script.main_frm \
    -borderwidth {0}

  # Build the first script-text-box (script_box_0)
  build_scriptbox .script.main_frm 0 $ascScripVect(font)
  pack append .script.main_frm \
    .script.main_frm.script_box_0 {top frame center expand fill}

  #
  # Build the menu bar and submenus
  #
  menu .script.menubar \
    -tearoffcommand .SCRIPT.MENUBAR \
    -tearoff 0

  # The Edit menu.
  menu .script.menubar.edit \
    -tearoffcommand .SCRIPT.MENUBAR.EDIT \
    -tearoff 0
  .script.menubar.edit add checkbutton  \
    -variable ascScripVect(Record) \
    -offvalue {0} \
    -onvalue {1} \
    -label {Record actions} \
    -underline 0
  .script.menubar.edit add command  \
    -command {Script_do_WriteFile} \
    -label {Write selection...} \
    -underline 0
  .script.menubar.edit add command  \
    -command {Script_do_SelectAll} \
    -label {Select all} \
    -underline 0
  .script.menubar.edit add separator
  .script.menubar.edit add command  \
    -command {Script_do_RemoveStats} \
    -label {Delete statements} \
    -underline 0


  # The Execute menu.
  menu .script.menubar.execute \
    -tearoffcommand .SCRIPT.MENUBAR.EXECUTE \
    -tearoff 0
  .script.menubar.execute add command  \
    -command {Script_do_ExecuteStats}  \
    -label {Statements selected} \
    -underline 0


  # The File menu
  menu .script.menubar.file \
    -tearoffcommand .SCRIPT.MENUBAR.FILE \
    -tearoff 0
  .script.menubar.file add command \
    -command {Script_do_NewFile} \
    -label {New file} \
    -underline 0
  .script.menubar.file add command  \
    -command {Script_do_ReadFile} \
    -label {Read file...} \
    -underline 0
  .script.menubar.file add command  \
    -command {Script_do_Import_File} \
    -label {Import file...} \
    -underline 0
  .script.menubar.file add separator
  .script.menubar.file add command  \
    -command {Script_do_Exit} \
    -label {Exit ASCEND...}
  .script.menubar.file add separator
  .script.menubar.file add command  \
    -command {Script_do_WriteBuf} \
    -label {Save} \
    -underline 0
  .script.menubar.file add command  \
    -command {Script_do_WriteBufAs} \
    -label {Save As...} \
    -underline 5
  .script.menubar.file add separator


  # The Help menu.
  menu .script.menubar.help \
    -tearoffcommand .SCRIPT.MENUBAR.HELP \
    -tearoff 0
  .script.menubar.help add command \
    -command {Script_do_Help} \
    -label {On Script} \
    -underline 3
  .script.menubar.help add command \
    -command {Script_getting_started} \
    -label {On getting started with ASCEND} \
    -underline 3


  # The Tools menu.
  menu .script.menubar.tools \
    -tearoffcommand .SCRIPT.MENUBAR.TOOLS \
    -tearoff 0
  .script.menubar.tools add checkbutton \
    -variable ascLibrVect(window.open) \
    -onvalue 1 \
    -offvalue 0 \
    -label {Type class library ...} \
    -underline 11
  .script.menubar.tools add checkbutton \
    -variable ascBrowVect(window.open) \
    -onvalue 1 \
    -offvalue 0 \
    -label {Instance browser ...} \
    -underline 9
  .script.menubar.tools add checkbutton \
    -variable ascProbVect(window.open) \
    -onvalue 1 \
    -offvalue 0 \
    -label {Data probe ...} \
    -underline 5
  .script.menubar.tools add checkbutton \
    -variable ascSolvVect(window.open) \
    -onvalue 1 \
    -offvalue 0 \
    -label {Solvers ...} \
    -underline 0
  .script.menubar.tools add checkbutton \
    -variable ascDispVect(window.open) \
    -onvalue 1 \
    -offvalue 0 \
    -label {Display slave ...} \
    -underline 0
  .script.menubar.tools add checkbutton \
    -variable ascUnitVect(window.open) \
    -onvalue 1 \
    -offvalue 0 \
    -label {Measuring units ...} \
    -underline 11
  .script.menubar.tools add checkbutton \
    -variable ascToolVect(window.open) \
    -onvalue 1 \
    -offvalue 0 \
    -label {Toolbox ...} \
    -underline 0
  .script.menubar.tools add separator
  .script.menubar.tools add command \
    -command {ascconsole_open} \
    -label {Open console} \
    -underline 5
  .script.menubar.tools add command \
    -command {ascplot_open} \
    -label {ASCPLOT ...} \
    -underline 3
  .script.menubar.tools add command \
    -command {Tool_do_UtilBox} \
    -label {System utilities ...} \
    -underline 7
  .script.menubar.tools add command \
    -command {Tool_do_Bugs} \
    -label {Report bug ...} \
    -underline 7


  # The View menu.
  menu .script.menubar.view \
    -tearoffcommand .SCRIPT.MENUBAR.VIEW \
    -tearoff 0
  .script.menubar.view add command  \
    -command {Script_do_Font}  \
    -label {Font ...} \
    -underline 0
  .script.menubar.view add command  \
    -command {Script_do_SaveOptions}  \
    -label {Save interface settings ...} \
    -underline 0


  #
  # Add the menus as cascades of the toplevel's menu;
  # add the toplevel's menu to the toplevel
  #
  .script.menubar add cascade \
    -menu .script.menubar.file \
    -label {File} \
    -underline 0
  .script.menubar add cascade \
    -menu .script.menubar.edit \
    -label {Edit} \
    -underline 0
  .script.menubar add cascade \
    -menu .script.menubar.execute \
    -label {Execute} \
    -underline 1
  .script.menubar add cascade \
    -menu .script.menubar.view \
    -label {View} \
    -underline 0
  .script.menubar add cascade \
    -menu .script.menubar.tools \
    -label {Tools} \
    -underline 0
  .script.menubar add cascade \
    -menu .script.menubar.help \
    -label {Help} \
    -underline 0
  .script configure \
    -menu .script.menubar

  #
  # Add the main frame and the bottom frame to the toplevel .script
  #
  pack append .script \
    .script.main_frm {top frame center expand fill} \
    .script.check_frm {top frame center fillx}

  EndSrc.script

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree .script"
    after 2 "catch {XFEditSetShowWindows}"
  }
}

# proc StartupSrc.script {args}
proc StartupSrc.script {args} {
# script startup entrance
# as much of the C/global dependencies managed here as possible
  global ascScripVect ascGlobalVect env
  if {[catch {set ascScripVect(windowname)} ]} {
    set ascScripVect(minsize) 10x10
    set ascScripVect(geometry) 37x21+10+10
    set ascScripVect(iconname) Script
    set ascScripVect(initialstate) normal
    set ascScripVect(font) "-*-*"
  }
  if {[catch {set ascGlobalVect(font)} ]} {
    set ascGlobalVect(font) "-*-*"
    set ascGlobalVect(labelfont) "-*-*"
    set ascGlobalVect(tbg) "white"
    set ascGlobalVect(tfg) "black"
    set ascGlobalVect(bg) "white"
    set ascGlobalVect(fg) "black"
    set ascGlobalVect(afg) "white"
    set ascGlobalVect(abg) "black"
    set ascGlobalVect(sfg) "white"
    set ascGlobalVect(sbg) "black"
    set ascGlobalVect(visibility) 1
    set ascGlobalVect(c_loaded) "0"
    set ascGlobalVect(toolbitmap) \
      "@$env(ASCENDBITMAPS)/toolAttributes.xbm"
  }
}

# proc EndSrc.script {}
proc EndSrc.script {} {
# script startup exit
  global ascScripVect
  set minw [lindex [split $ascScripVect(minsize) x] 0]
  set minh [lindex [split $ascScripVect(minsize) x] 1]
  set gw [lindex [split [lindex [split $ascScripVect(geometry) +] 0] x] 0]
  set gh [lindex [split [lindex [split $ascScripVect(geometry) +] 0] x] 1]
  set gpx [lindex [split [split $ascScripVect(geometry) x] +] 1]
  set gpy [lindex [split [split $ascScripVect(geometry) x] +] 2]
  if {[expr $gw < $minw]} {set gw $minw}
  if {[expr $gh < $minh]} {set gh $minh}
  set gwh "${gw}x${gh}"
  wm minsize .script $minw $minh
  wm geometry .script "${gwh}+${gpx}+$gpy"
  # wm geometry .script [gospos .script $gpx $gpy]
  wm iconname .script $ascScripVect(iconname)

  if {$ascScripVect(initialstate)!="iconic" && \
      $ascScripVect(initialstate)!="iconified" && \
      $ascScripVect(initialstate) !="withdrawn"} {
    wm deiconify .script
  }
  if {"$ascScripVect(initialstate)"=="withdrawn"} {
    wm withdraw .script
  }

}


# User defined procedures
 # repeated here for standalone use. main definition is in generalk.tcl
proc osgpos {geom} {
  set sh [winfo screenheight .]; set sw [winfo screenwidth .]
  set glist [split $geom +-]
  if {[llength $glist] != 3} {error "Invalid geometry spec passed to osg"}
  set x [lindex $glist 1] ; set y [lindex $glist 2]
  set slist [split [lindex $glist 0] x]
  if {[llength $slist] != 2} {error "Invalid window size given to osg"}
  set w [lindex $slist 0] ; set h [lindex $slist 1]
  set newx $x ; set newy $y
  if {($x + $w) > $sw} {set newx [expr $sw - $w]}
  if {($y + $h) > $sh} {set newy [expr $sh - $h]}
  if { $newx < 2 } {set newx 2} ; if { $newy < 2 } {set newy 2}
  return [lindex $glist 0]+$newx+$newy
}
proc setpos {master {offsetx "70"} {offsety "70"}} {# calculates offsets
  set xpos [expr [winfo rootx $master] + $offsetx]
  set ypos [expr [winfo rooty $master] + $offsety]
  return "+$xpos+$ypos"
}
proc ospos {w h x y} {
  set sh [winfo screenheight .] ; set sw [winfo screenwidth .]
  set newx $x ; set newy $y
  if {($x + $w) > $sw} {set newx [expr $sw - $w]}
  if {($y + $h) > $sh} {set newy [expr $sh - $h]}
  if { $newx < 2 } {set newx 2} ; if { $newy < 2 } {set newy 2}
  return ${w}x${h}+$newx+$newy
}
proc gospos {gw x y} {
  set h [winfo height $gw] ; set w [winfo width $gw]
  set pgeom [ospos $w $h $x $y]
  set px +[lindex [split $pgeom +] 1]
  set py +[lindex [split $pgeom +] 2]
  set wgeom [wm geometry $gw]
  set wsize [lindex [split $wgeom +] 0]
  return ${wsize}${px}${py}
}


#
# proc build_scriptbox {parentname winnum font}
#---------------------------------------------------------------------------
# creates a text widget with scrollbars in the context
# of parentname, if same does not already exist.
# the name of the text widget is
# $parentname.script_box_$winnum
# returns the name $parentname.script_box_$winnum
# The widget with this name has a child named text2.
# scrollbars are done with bg/fg colors
# text is done with tbg/tfg, sbg/sfg for plain and selected text,
# respectively.
# if the widget already exists, recolors it from the given input.
#---------------------------------------------------------------------------
#
proc build_scriptbox {parentname winnum font} {

  if {[winfo exists  $parentname.script_box_$winnum]} {
    return $parentname.script_box_$winnum
  }

  # build widget $parentname.script_box_$winnum
  frame $parentname.script_box_$winnum \
    -relief {raised}

  # build widget $parentname.script_box_$winnum.scrollbar1
  scrollbar $parentname.script_box_$winnum.scrollbar1 \
    -command "$parentname.script_box_$winnum.text2 yview"

  # build widget $parentname.script_box_$winnum.text2
  text $parentname.script_box_$winnum.text2  \
    -exportselection 0 \
    -borderwidth {2} \
    -height {2} \
    -relief {raised} \
    -setgrid {1} \
    -width {10} \
    -wrap {word} \
    -yscrollcommand "$parentname.script_box_$winnum.scrollbar1 set" \
    -font $font

  # pack widget $parentname.script_box_$winnum
  pack append $parentname.script_box_$winnum \
     $parentname.script_box_$winnum.scrollbar1 {right frame center filly} \
     $parentname.script_box_$winnum.text2 {top frame center expand fill}
  catch {emacs-bind $parentname.script_box_$winnum.text2}
}


# Internal procedures

# eof
#
