# Module: toolbox.tcl
# Tcl version: 7.1 (Tcl/Tk/XF)
# Tk version: 3.4
# XF version: 2.2
# (C) Kirk Abbott, Ben Allan 1994
# $Revision: 1.8 $
# $Date: 97/06/23 16:29:29 $
#

# module contents
global moduleList
global autoLoadList
set moduleList(toolbox.tcl) { .toolbox do_raise do_raise_lower}
set autoLoadList(toolbox.tcl) {0}

# procedures to show toplevel windows


# procedure to show window ShowWindow.toolbox
# proc ShowWindow.toolbox { args}
proc ShowWindow.toolbox { args} {
# xf ignore me 7

  global env ascGlobalVect ascToolVect
StartupSrc.toolbox

  # build widget .toolbox
  if {"[info procs XFEdit]" != ""} {
    catch "XFDestroy .toolbox"
  } {
    catch "destroy .toolbox"
  }
  toplevel .toolbox   -borderwidth {2}

  # Window manager configurations
  wm iconify .toolbox
  wm positionfrom .toolbox user
  wm sizefrom .toolbox user
  wm iconname .toolbox {Toolbox}
  wm minsize .toolbox 100 100
  wm title .toolbox {A4 Toolbox}
  wm protocol .toolbox WM_DELETE_WINDOW {EXIT}

  # build widget .toolbox.bottom_frm
  frame .toolbox.bottom_frm

  # build widget .toolbox.bottom_frm.browser_btn
  button .toolbox.bottom_frm.browser_btn \
    -text {BROWSER} \
    -font $ascGlobalVect(font)


  # build widget .toolbox.bottom_frm.display_btn
  button .toolbox.bottom_frm.display_btn \
    -text {DISPLAY} \
    -font $ascGlobalVect(font)

  # build widget .toolbox.bottom_frm.library_btn
  button .toolbox.bottom_frm.library_btn \
    -text {LIBRARY} \
    -font $ascGlobalVect(font)

  # build widget .toolbox.bottom_frm.probe_btn
  button .toolbox.bottom_frm.probe_btn \
    -text {PROBE} \
    -font $ascGlobalVect(font)

  # build widget .toolbox.bottom_frm.script_btn
  button .toolbox.bottom_frm.script_btn \
    -text {SCRIPT} \
    -font $ascGlobalVect(font)

  # build widget .toolbox.bottom_frm.solver_btn
  button .toolbox.bottom_frm.solver_btn \
    -text {SOLVER} \
    -font $ascGlobalVect(font)

  # build widget .toolbox.bottom_frm.units_btn
  button .toolbox.bottom_frm.units_btn \
    -text {UNITS} \
    -font $ascGlobalVect(font)

  # build widget .toolbox.bottom_frm.util_btn
  button .toolbox.bottom_frm.util_btn \
    -text {utilities} \
    -font $ascGlobalVect(font) \
    -command Tool_do_UtilBox

  # build widget .toolbox.bottom_frm.exit_btn
  button .toolbox.bottom_frm.exit_btn \
    -text {exit} \
    -font $ascGlobalVect(font)

  # build widget .toolbox.bottom_frm.bug_btn
  button .toolbox.bottom_frm.bug_btn \
    -font $ascGlobalVect(font) \
    -text {bug report} \
    -command {Tool_do_Bugs}

  # build widget .toolbox.bottom_frm.plot_btn
  button .toolbox.bottom_frm.plot_btn \
    -font $ascGlobalVect(font) \
    -text {ascplot} \
    -command {ascplot_open}

  # build widget .toolbox.bottom_frm.hlp_btn
  button .toolbox.bottom_frm.hlp_btn \
    -text {help} \
    -font $ascGlobalVect(font)

  # pack widget .toolbox.bottom_frm
  pack append .toolbox.bottom_frm \
    .toolbox.bottom_frm.exit_btn {top frame center expand fillx} \
    .toolbox.bottom_frm.plot_btn {top frame center expand fillx} \
    .toolbox.bottom_frm.hlp_btn {top frame center expand fillx} \
    .toolbox.bottom_frm.util_btn {top frame center expand fillx} \
    .toolbox.bottom_frm.bug_btn {top frame center expand fillx} \
    .toolbox.bottom_frm.library_btn {top frame center expand fillx} \
    .toolbox.bottom_frm.browser_btn {top frame center expand fillx} \
    .toolbox.bottom_frm.solver_btn {top frame center expand fillx} \
    .toolbox.bottom_frm.probe_btn {top frame center expand fillx} \
    .toolbox.bottom_frm.units_btn {top frame center expand fillx} \
    .toolbox.bottom_frm.display_btn {top frame center expand fillx} \
    .toolbox.bottom_frm.script_btn {top frame center expand fillx}

  # pack widget .toolbox
  pack append .toolbox  \
    .toolbox.bottom_frm {top frame center expand fill}

EndSrc.toolbox

  if {"[info procs XFEdit]" != ""} {
    catch "XFMiscBindWidgetTree .toolbox"
    after 2 "catch {XFEditSetShowWindows}"
  }
}

# proc DestroyWindow.toolbox {}
proc DestroyWindow.toolbox {} {# xf ignore me 7
  if {"[info procs XFEdit]" != ""} {
    if {"[info commands .toolbox]" != ""} {
      global xfShowWindow.toolbox
      set xfShowWindow.toolbox 0
      XFEditSetPath .
      after 2 "XFSaveAsProc .toolbox; XFEditSetShowWindows"
    }
  } {
    catch "destroy .toolbox"
    update
  }
}

# proc StartupSrc.toolbox {args}
proc StartupSrc.toolbox {args} {
#toolbox startup entrance
  global ascToolVect ascGlobalVect env
  if {[catch {set ascToolVect(windowname)} ]} {
    set ascToolVect(minsize) 20x100 
    set ascToolVect(geometry) +10+10
    set ascToolVect(iconname) Toolbox
    set ascToolVect(initialstate) normal
    set ascToolVect(font) "-*-*"
  }
  if {[catch {set ascGlobalVect(font)} ]} {
    set ascGlobalVect(font) "-*-*"
    set ascGlobalVect(labelfont) "-*-*"
    set ascGlobalVect(visibility) 1
    set ascGlobalVect(c_loaded) 0
    set ascGlobalVect(toolbitmap) \
      "@$env(ASCENDBITMAPS)/toolAttributes.xbm"
  }
}

# proc EndSrc.toolbox {}
proc EndSrc.toolbox {} {
  global ascToolVect
  set minw [lindex [split $ascToolVect(minsize) x] 0]
  set minh [lindex [split $ascToolVect(minsize) x] 1]
  set gw [lindex [split [lindex [split $ascToolVect(geometry) +] 0] x] 0]
  set gh [lindex [split [lindex [split $ascToolVect(geometry) +] 0] x] 1]
  set gp "+[lindex [split [split $ascToolVect(geometry) x] +] 1]+[lindex [split [split $ascToolVect(geometry) x] +] 2]"
  if {[expr $gw < $minw]} {set gw $minw}
  if {[expr $gh < $minh]} {set gh $minh}
  set gwh "${gw}x${gh}"
  wm positionfrom .toolbox ""
  wm sizefrom .toolbox ""
  wm maxsize .toolbox 1000 1000
  wm minsize .toolbox $minw $minh
 # wm geometry .toolbox [osgpos $gwh$gp]
  wm title .toolbox {ASCEND Toolbox}
  wm iconname .toolbox $ascToolVect(iconname)

  if {$ascToolVect(initialstate)!="iconic" && \
      $ascToolVect(initialstate)!="iconified" && \
      $ascToolVect(initialstate)!="withdrawn"} {
    wm deiconify .toolbox
  }
  if {$ascToolVect(initialstate)=="withdrawn"} {
    wm withdraw .toolbox
  }
}


# User defined procedures

 # repeated here for standalone use. main definition is in generalk.tcl
proc osgpos {geom} {
  set sh [winfo screenheight .]; set sw [winfo screenwidth .]
  set glist [split $geom +-]
  if {[llength $glist] != 3} {error "Invalid geometry spec passed to osg"}
  set x [lindex $glist 1] ; set y [lindex $glist 2]
  set slist [split [lindex $glist 0] x]
  if {[llength $slist] != 2} {error "Invalid window size given to osg"}
  set w [lindex $slist 0] ; set h [lindex $slist 1]
  set newx $x ; set newy $y
  if {($x + $w) > $sw} {set newx [expr $sw - $w]}
  if {($y + $h) > $sh} {set newy [expr $sh - $h -20]}
  if { $newx < 2 } {set newx 2} ; if { $newy < 2 } {set newy 2}
  return [lindex $glist 0]+$newx+$newy
}
proc setpos {master {offsetx "70"} {offsety "70"}} {# calculates offsets
  set xpos [expr [winfo rootx $master] + $offsetx]
  set ypos [expr [winfo rooty $master] + $offsety]
  return "+$xpos+$ypos"
}


# Internal procedures

# eof
#

