/*
 *  Exceptions.h
 *  by Kirk Abbott and Ben Allan
 *  Created: 1/94
 *  Version: $Revision: 1.4 $
 *  Version control file: $RCSfile: Exceptions.h,v $
 *  Date last modified: $Date: 97/07/18 12:22:59 $
 *  Last modified by: $Author: mthomas $
 *
 *  This file is part of the ASCEND Tcl/Tk interface
 *
 *  Copyright 1997, Carnegie Mellon University
 *
 *  The ASCEND Tcl/Tk interface is free software; you can redistribute
 *  it and/or modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, or (at your option) any later version.
 *
 *  The ASCEND Tcl/Tk interface is distributed in hope that it will be
 *  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with the program; if not, write to the Free Software Foundation,
 *  Inc., 675 Mass Ave, Cambridge, MA 02139 USA.  Check the file named
 *  COPYING.  COPYING is found in ../compiler.
 */

#ifndef Exceptions_module_loaded
#define Exceptions_module_loaded

/* requires #include <stdio.h> */
/* requires #include <signal.h> */
/* requires #include <setjmp.h> */

extern jmp_buf g_brow_env;
extern jmp_buf g_slv_fp_env;
extern jmp_buf g_slv_int_env;
extern jmp_buf g_libr_env;
extern jmp_buf g_unit_env;
extern jmp_buf g_env;

/* jmp data for
  browser(instances)
  solver(solving)
  library(type tree)
  and interface (everything else)
  g_unit_env (unit conversion)
*/

extern void (*fault_set_seg_trap(void (*trapptr)(int)))(int);
/* segmentation fault */
extern void (*fault_set_int_trap(void (*trapptr)(int)))(int);
 /* interactive attention */
extern void (*fault_set_fp_trap(void (*trapptr)(int)))(int);
/* floating point err */
/*
 *  Call these functions with the pointer to an error handling routine
 *  in a setjmp based conditional wrapped around the likely to err
 *  subroutines. To turn return to default err action, call these with
 *  SIG_DFL. To ignore a signal, call these with SIG_IGN.
 *  *                                                                     *
 *  These functions return the previous value of trapptr. Set things
 *  back the way you found them if your call might be nested in
 *  some other C call, which is the case with all non-solver fp traps.
 *  The solver has outermost status on the fp_trap. Anyone setting the
 *  fp_trap for some other use should set it back when they are done
 *  with it.
 *  *                                                                     *
 *  On MACH (short for Mutilated And Changed Headers) machines, note
 *  SIG_ERR seems to have been warped to BADSIG.
 */
#endif
